package org.apache.bcel.classfile;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataInput;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantObject;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.Visitor;

public final class ConstantString extends Constant implements ConstantObject {
  private int stringIndex;
  
  public ConstantString(org.apache.bcel.classfile.ConstantString c) {
    this(c.getStringIndex());
  }
  
  ConstantString(DataInput file) throws IOException {
    this(file.readUnsignedShort());
  }
  
  public ConstantString(int stringIndex) {
    super((byte)8);
    this.stringIndex = stringIndex;
  }
  
  public void accept(Visitor v) {
    v.visitConstantString(this);
  }
  
  public void dump(DataOutputStream file) throws IOException {
    file.writeByte(getTag());
    file.writeShort(this.stringIndex);
  }
  
  public String getBytes(ConstantPool cp) {
    return (String)getConstantValue(cp);
  }
  
  public Object getConstantValue(ConstantPool cp) {
    return cp.getConstantUtf8(this.stringIndex).getBytes();
  }
  
  public int getStringIndex() {
    return this.stringIndex;
  }
  
  public void setStringIndex(int stringIndex) {
    this.stringIndex = stringIndex;
  }
  
  public String toString() {
    return super.toString() + "(stringIndex = " + this.stringIndex + ")";
  }
}
